Index: src/Descriptors/MoleculeIdDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculeIdDescriptor.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/MoleculeIdDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "MoleculeIdDescriptor.hpp"
 #include "MoleculeIdDescriptor_impl.hpp"
+
+#include "Patterns/ObservedContainer_impl.hpp"
 
 #include "molecule.hpp"
@@ -32,5 +39,5 @@
 
 molecule *MoleculeIdDescriptor_impl::find(){
-  World::MoleculeSet molecules = getMolecules();
+  World::MoleculeSet &molecules = getMolecules();
   World::MoleculeSet::iterator res = molecules.find(id);
   return (res!=molecules.end())?((*res).second):0;
Index: src/Descriptors/MoleculeNameDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculeNameDescriptor.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/MoleculeNameDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,11 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
 
 #include "MoleculeNameDescriptor.hpp"
@@ -30,5 +37,5 @@
 
 molecule *MoleculeNameDescriptor_impl::find(){
-  World::MoleculeSet molecules = getMolecules();
+  World::MoleculeSet &molecules = getMolecules();
   World::MoleculeSet::iterator res = molecules.begin();
   for (; res != molecules.end(); res++)
Index: src/Descriptors/MoleculePtrDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculePtrDescriptor.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/MoleculePtrDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "MoleculePtrDescriptor.hpp"
 #include "MoleculePtrDescriptor_impl.hpp"
+
+#include "Patterns/ObservedContainer_impl.hpp"
 
 #include "molecule.hpp"
@@ -32,5 +39,5 @@
 
 molecule *MoleculePtrDescriptor_impl::find(){
-  World::MoleculeSet molecules = getMolecules();
+  World::MoleculeSet &molecules = getMolecules();
   World::MoleculeSet::iterator res = molecules.find(ptr->getId());
   return (res!=molecules.end())?((*res).second):0;
Index: src/Descriptors/MoleculeSelectionDescriptor.cpp
===================================================================
--- src/Descriptors/MoleculeSelectionDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/MoleculeSelectionDescriptor.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,50 @@
+/*
+ * MoleculeSelectionDescriptor.cpp
+ *
+ *  Created on: Jul 16, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Descriptors/MoleculeSelectionDescriptor.hpp"
+#include "Descriptors/MoleculeSelectionDescriptor_impl.hpp"
+
+#include "Helpers/helpers.hpp"
+
+MoleculeSelectionDescriptor_impl::MoleculeSelectionDescriptor_impl(){}
+
+MoleculeSelectionDescriptor_impl::~MoleculeSelectionDescriptor_impl(){}
+
+bool MoleculeSelectionDescriptor_impl::predicate(std::pair<moleculeId_t,molecule*> molecule){
+  return getSelectedMolecules().count(molecule.first);
+}
+
+molecule* MoleculeSelectionDescriptor_impl::find(){
+  World::MoleculeSet &set = getSelectedMolecules();
+  World::MoleculeSet::internal_iterator begin = set.begin_internal();
+  return (begin!=set.end_internal())?(begin->second):0;
+}
+
+std::vector<molecule*> MoleculeSelectionDescriptor_impl::findAll(){
+  std::vector<molecule*> res;
+  World::MoleculeSet &set = getSelectedMolecules();
+  transform(set.begin_internal(),
+           set.end_internal(),
+           back_inserter(res),
+           _take<molecule*,World::MoleculeSet::value_type>::get);
+  return res;
+}
+
+World::MoleculeSet& MoleculeSelectionDescriptor_impl::getSelectedMolecules(){
+  return World::getInstance().selectedMolecules;
+}
+
+MoleculeDescriptor MoleculesBySelection(){
+  return MoleculeDescriptor(MoleculeDescriptor::impl_ptr(new MoleculeSelectionDescriptor_impl()));
+}
Index: src/Descriptors/MoleculeSelectionDescriptor.hpp
===================================================================
--- src/Descriptors/MoleculeSelectionDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/MoleculeSelectionDescriptor.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,15 @@
+/*
+ * MoleculeSelectionDescriptor.hpp
+ *
+ *  Created on: Jul 16, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULESELECTIONDESCRIPTOR_HPP_
+#define MOLECULESELECTIONDESCRIPTOR_HPP_
+
+#include "Descriptors/MoleculeDescriptor.hpp"
+
+MoleculeDescriptor MoleculesBySelection();
+
+#endif /* MOLECULESELECTIONDESCRIPTOR_HPP_ */
Index: src/Descriptors/MoleculeSelectionDescriptor_impl.hpp
===================================================================
--- src/Descriptors/MoleculeSelectionDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Descriptors/MoleculeSelectionDescriptor_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,26 @@
+/*
+ * MoleculeSelectionDescriptor_impl.hpp
+ *
+ *  Created on: Jul 16, 2010
+ *      Author: crueger
+ */
+
+#ifndef MOLECULESELECTIONDESCRIPTOR_IMPL_HPP_
+#define MOLECULESELECTIONDESCRIPTOR_IMPL_HPP_
+
+#include "Descriptors/MoleculeDescriptor_impl.hpp"
+
+class MoleculeSelectionDescriptor_impl : public MoleculeDescriptor_impl{
+public:
+  MoleculeSelectionDescriptor_impl();
+  virtual ~MoleculeSelectionDescriptor_impl();
+  bool predicate(std::pair<moleculeId_t,molecule*> molecule);
+protected:
+  // need to overide more than the standard methods to make this fast
+  virtual molecule* find();
+  virtual std::vector<molecule*> findAll();
+
+  World::MoleculeSet& getSelectedMolecules();
+};
+
+#endif /* MOLECULESELECTIONDESCRIPTOR_IMPL_HPP_ */
Index: src/Descriptors/SelectiveIterator_impl.hpp
===================================================================
--- src/Descriptors/SelectiveIterator_impl.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Descriptors/SelectiveIterator_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -9,5 +9,5 @@
 #define SELECTIVEITERATOR_IMPL_HPP_
 
-#include "helpers.hpp"
+#include "Helpers/helpers.hpp"
 
 template<class _Target,
Index: src/Exceptions/CustomException.cpp
===================================================================
--- src/Exceptions/CustomException.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Exceptions/CustomException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,13 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "CustomException.hpp"
+#include <iostream>
 
 using namespace std;
Index: src/Exceptions/CustomException.hpp
===================================================================
--- src/Exceptions/CustomException.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Exceptions/CustomException.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -10,5 +10,6 @@
 
 #include <exception>
-#include <iostream>
+#include <iosfwd>
+#include <string>
 
 /**
Index: src/Exceptions/IllegalTypeException.cpp
===================================================================
--- src/Exceptions/IllegalTypeException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/IllegalTypeException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,28 @@
+/*
+ * IllegalTypeException.cpp
+ *
+ *  Created on: Jun 25, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "IllegalTypeException.hpp"
+
+using namespace std;
+
+IllegalTypeException::IllegalTypeException(string _file, int _line) :
+  CustomException(_file,_line)
+{}
+
+IllegalTypeException::~IllegalTypeException() throw ()
+{}
+
+const char* IllegalTypeException::what() const throw(){
+  return "Illegal type in cast";
+}
Index: src/Exceptions/IllegalTypeException.hpp
===================================================================
--- src/Exceptions/IllegalTypeException.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/IllegalTypeException.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,22 @@
+/*
+ * IllegalTypeException.hpp
+ *
+ *  Created on: Jun 25, 2010
+ *      Author: crueger
+ */
+
+#ifndef ILLEGALTYPEEXCEPTION_HPP_
+#define ILLEGALTYPEEXCEPTION_HPP_
+
+#include "Exceptions/CustomException.hpp"
+
+class IllegalTypeException : public CustomException
+{
+public:
+  IllegalTypeException(std::string _file, int _line);
+  virtual ~IllegalTypeException() throw ();
+
+  virtual const char* what() const throw();
+};
+
+#endif /* ILLEGALTYPEEXCEPTION_HPP_ */
Index: src/Exceptions/LinearDependenceException.cpp
===================================================================
--- src/Exceptions/LinearDependenceException.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Exceptions/LinearDependenceException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Exceptions/Makefile.am
===================================================================
--- src/Exceptions/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/Makefile.am	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,80 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
+INCLUDES = -I$(top_srcdir)/src
+
+AM_LDFLAGS = $(CPPUNIT_LIBS) -ldl
+# Position-Independent Code necessary for shared library
+AM_CXXFLAGS = $(CPPUNIT_CFLAGS)
+
+EXCEPTIONSOURCE = \
+  CustomException.cpp \
+  IllegalTypeException.cpp \
+  LinearDependenceException.cpp \
+  MathException.cpp \
+  MissingValueException.cpp \
+  NotInvertibleException.cpp \
+  ParseError.cpp \
+  SkewException.cpp \
+  ZeroVectorException.cpp
+				  
+EXCEPTIONHEADER = \
+  CustomException.hpp \
+  IllegalTypeException.hpp \
+  LinearDependenceException.hpp \
+  MathException.hpp \
+  MissingValueException.hpp \
+  NotInvertibleException.hpp \
+  ParseError.hpp \
+  SkewException.hpp \
+  ZeroVectorException.hpp
+
+
+
+lib_LTLIBRARIES = libMolecuilderExceptions-@MOLECUILDER_API_VERSION@.la
+libMolecuilderExceptions_includedir = $(includedir)/molecuilder-$(MOLECUILDER_API_VERSION)/Actions/
+nobase_libMolecuilderExceptions_include_HEADERS = ${EXCEPTIONHEADER}
+
+## Define the source file list for the "libexample-@MOLECUILDER_API_VERSION@.la"
+## target.  Note that @MOLECUILDER_API_VERSION@ is not interpreted by Automake and
+## will therefore be treated as if it were literally part of the target name,
+## and the variable name derived from that.
+## The file extension .cc is recognized by Automake, and makes it produce
+## rules which invoke the C++ compiler to produce a libtool object file (.lo)
+## from each source file.  Note that it is not necessary to list header files
+## which are already listed elsewhere in a _HEADERS variable assignment.
+libMolecuilderExceptions_@MOLECUILDER_API_VERSION@_la_SOURCES = ${EXCEPTIONSOURCE}
+
+## Instruct libtool to include ABI version information in the generated shared
+## library file (.so).  The library ABI version is defined in configure.ac, so
+## that all version information is kept in one place.
+libMolecuilderExceptions_@MOLECUILDER_API_VERSION@_la_LDFLAGS = -version-info $(MOLECUILDER_SO_VERSION)
+
+## The generated configuration header is installed in its own subdirectory of
+## $(libdir).  The reason for this is that the configuration information put
+## into this header file describes the target platform the installed library
+## has been built for.  Thus the file must not be installed into a location
+## intended for architecture-independent files, as defined by the Filesystem
+## Hierarchy Standard (FHS).
+## The nodist_ prefix instructs Automake to not generate rules for including
+## the listed files in the distribution on 'make dist'.  Files that are listed
+## in _HEADERS variables are normally included in the distribution, but the
+## configuration header file is generated at configure time and should not be
+## shipped with the source tarball.
+libMolecuilderExceptions_libincludedir = $(libdir)/molecuilder-$(MOLECUILDER_API_VERSION)/include
+nodist_libMolecuilderExceptions_libinclude_HEADERS = $(top_builddir)/libmolecuilder_config.h
+
+## Install the generated pkg-config file (.pc) into the expected location for
+## architecture-dependent package configuration information.  Occasionally,
+## pkg-config files are also used for architecture-independent data packages,
+## in which case the correct install location would be $(datadir)/pkgconfig.
+pkgconfigdir = $(libdir)/pkgconfig
+pkgconfig_DATA = $(top_builddir)/molecuilder-$(MOLECUILDER_API_VERSION).pc
+
+unity.cpp:
+	echo "" >  unity.cpp; \
+	list='$(EXCEPTIONSOURCE)'; for file in $$list; do \
+	  echo "#include \"$(srcdir)/$$file\"" >> unity.cpp; \
+	done;
+	
+MOSTLYCLEANFILES = unity.cpp
Index: src/Exceptions/MathException.cpp
===================================================================
--- src/Exceptions/MathException.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Exceptions/MathException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Exceptions/MissingValueException.cpp
===================================================================
--- src/Exceptions/MissingValueException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/MissingValueException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,28 @@
+/*
+ * MissingValueException.cpp
+ *
+ *  Created on: Jul 23, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "MissingValueException.hpp"
+
+using namespace std;
+
+MissingValueException::MissingValueException(string _file, int _line) :
+  CustomException(_file,_line)
+{}
+
+MissingValueException::~MissingValueException() throw ()
+{}
+
+const char* MissingValueException::what() const throw(){
+  return "Value necessary for Action not present in ValueStorage";
+}
Index: src/Exceptions/MissingValueException.hpp
===================================================================
--- src/Exceptions/MissingValueException.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/MissingValueException.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,22 @@
+/*
+ * MissingValueException.hpp
+ *
+ *  Created on: Jul 23, 2010
+ *      Author: heber
+ */
+
+#ifndef MISSINGVALUEEXCEPTION_HPP_
+#define MISSINGVALUEEXCEPTION_HPP_
+
+#include "Exceptions/CustomException.hpp"
+
+class MissingValueException : public CustomException
+{
+public:
+  MissingValueException(std::string _file, int _line);
+  virtual ~MissingValueException() throw ();
+
+  virtual const char* what() const throw();
+};
+
+#endif /* MISSINGVALUEEXCEPTION_HPP_ */
Index: src/Exceptions/NotInvertibleException.cpp
===================================================================
--- src/Exceptions/NotInvertibleException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/NotInvertibleException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,28 @@
+/*
+ * NotInvertibleException.cpp
+ *
+ *  Created on: Jun 25, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "NotInvertibleException.hpp"
+
+using namespace std;
+
+NotInvertibleException::NotInvertibleException(string _file, int _line) :
+  MathException(_file,_line)
+{}
+
+NotInvertibleException::~NotInvertibleException() throw ()
+{}
+
+const char* NotInvertibleException::what() const throw(){
+  return "Given Matrix is not invertible";
+}
Index: src/Exceptions/NotInvertibleException.hpp
===================================================================
--- src/Exceptions/NotInvertibleException.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/NotInvertibleException.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,22 @@
+/*
+ * NotInvertibleException.hpp
+ *
+ *  Created on: Jun 25, 2010
+ *      Author: crueger
+ */
+
+#ifndef NOTINVERTIBLEEXCEPTION_HPP_
+#define NOTINVERTIBLEEXCEPTION_HPP_
+
+#include "Exceptions/MathException.hpp"
+
+class NotInvertibleException : public MathException
+{
+public:
+  NotInvertibleException(std::string _file, int _line);
+  virtual ~NotInvertibleException() throw ();
+
+  virtual const char* what() const throw();
+};
+
+#endif /* NOTINVERTIBLEEXCEPTION_HPP_ */
Index: src/Exceptions/ParseError.cpp
===================================================================
--- src/Exceptions/ParseError.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/ParseError.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,25 @@
+/*
+ * ParseError.cpp
+ *
+ *  Created on: Jul 21, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "ParseError.hpp"
+
+ParseError::ParseError(std::string file, int line) :
+  CustomException(file,line)
+{}
+
+ParseError::~ParseError() throw(){}
+
+const char* ParseError::what() const throw(){
+  return "Could not parse string";
+}
Index: src/Exceptions/ParseError.hpp
===================================================================
--- src/Exceptions/ParseError.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Exceptions/ParseError.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,22 @@
+/*
+ * ParseError.hpp
+ *
+ *  Created on: Jul 21, 2010
+ *      Author: crueger
+ */
+
+#ifndef PARSEERROR_HPP_
+#define PARSEERROR_HPP_
+
+#include "Exceptions/CustomException.hpp"
+
+class ParseError : public CustomException
+{
+public:
+  ParseError(std::string file, int line);
+  virtual ~ParseError() throw();
+
+  virtual const char* what() const throw();
+};
+
+#endif /* PARSEERROR_HPP_ */
Index: src/Exceptions/SkewException.cpp
===================================================================
--- src/Exceptions/SkewException.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Exceptions/SkewException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Exceptions/ZeroVectorException.cpp
===================================================================
--- src/Exceptions/ZeroVectorException.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Exceptions/ZeroVectorException.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -5,4 +5,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
